#!/usr/bin/ruby
# encoding: utf-8

require '../kr/plot'

def fwt(a)
  return a if a.size == 1

  left = a[0...a.size/2]
  right = a[a.size/2..-1]

  y = []
  (0...a.size/2).each do |j|
    y[j] = left[j] + right[j]
    y[j + a.size/2] = left[j] - right[j]
  end

  left = fwt(y[0...y.size/2])
  right = fwt(y[y.size/2..-1])

  left + right
end

def f1(x)
  Math.cos(x) + Math.sin(3*x)
end

plot("cos(x) + sin(3*x)", :xrange => "[0:2*pi]", :filename => "source.eps")

N = 31
i, x = 0, []
step = 2*Math::PI / N
until i > 2*Math::PI
  x << (f1(i) > 0 ? 1 : -1)
  i += step
end

data = [(0..N).to_a, x]
plot(data, :xrange => "[0:#{N}]", :yrange => "[-2:2]", :filename => "x.eps", :style => "stem")

y = fwt(x)
data = [(0..N).to_a, y]
plot(data, :xrange => "[0:#{N}]", :filename => "fwt.eps", :style => "stem")

y1 = fwt(y).map{|i| i/(N+1)}
data = [(0..N).to_a, y1]
plot(data, :xrange => "[0:#{N}]", :yrange => "[-2:2]", :filename => "ifwt.eps", :style => "stem")
